int OnBackToMainMenu(int enter);
int ResetScreen(int showmenu, int showback);
void MainMenu(int sel);

void extractData(char* device, char* outfile, SceSize size, int seek);
void extractIPL(char* device, char* outfile, int type);
void eraseIPL(char* device);
void injectIPL_File(char* device, char* infile);
void injectIPL(char* device, char* data, int size);
void checkIPL(char* input, int type);
void createCheckSum(char* input, char* outfile, int type);

void about();
void ConnectUSB(u32 device);
void checkMSinfo(char* input, int type);
int getMSinfo(char* input, int type);

struct IPLchecksums {
	char*	name;
	int		size;
	u8		checksum[20];
} IPLchecksums[] = {
	{"Blank (no IPL)", 0, {0x1C, 0xEA, 0xF7, 0x3D, 0xF4, 0x0E, 0x53, 0x1D, 0xF3, 0xBF, 0xB2, 0x6B, 0x4F, 0xB7, 0xCD, 0x95, 0xFB, 0x7B, 0xFF, 0x1D}},
	{"Boosters Multi IPL", 15620, {0x70, 0x78, 0xFE, 0x54, 0x08, 0x9F, 0x2F, 0xE5, 0x46, 0x33, 0xE8, 0x6D, 0x82, 0x3D, 0x54, 0xAE, 0xAA, 0x77, 0x15, 0x76}},
	{"Classic Pandora IPL", 241664, {0xB5, 0xF8, 0xAF, 0xF8, 0xB5, 0x6A, 0x06, 0x4D, 0x32, 0xE6, 0xE5, 0xEE, 0x92, 0x96, 0xBD, 0xD2, 0x26, 0x1A, 0xCD, 0x2A}},
	{"Datel Action Replay PSP", 8192, {0x57, 0x1C, 0x2C, 0x9C, 0xB6, 0xCE, 0xFF, 0x09, 0x57, 0x1C, 0xE8, 0x03, 0x32, 0xD3, 0x1E, 0x13, 0x1F, 0xE0, 0xFA, 0x82}},
	{"Time Machine", 12288, {0x9C, 0x72, 0xD8, 0x5B, 0x0F, 0xE2, 0x8C, 0x4F, 0xF8, 0x93, 0xC1, 0xA1, 0x2C, 0x7F, 0x54, 0x72, 0x45, 0x28, 0xEF, 0xFB}},
	{"z3ros0ul Multi IPL (Sleep Fix)", 13744, {0xE9, 0x23, 0x9E, 0xC7, 0x5F, 0xBC, 0x93, 0x4A, 0x75, 0xC5, 0x75, 0xF1, 0x35, 0x7D, 0x52, 0x68, 0x7E, 0xD6, 0x8A, 0x32}},
	{"z3ros0ul Single IPL (Sleep Fix)", 2296, {0x4C, 0x68, 0x33, 0x0A, 0x98, 0x6C, 0xC6, 0x5E, 0x9F, 0x9E, 0xB3, 0xF1, 0x88, 0x36, 0xF2, 0x1D, 0xC1, 0xCE, 0x0C, 0xCD}},
	{"TA-088v3 Ident Test 1 (3.90 IPL)", 151552, {0xAE, 0x7D, 0x39, 0xB8, 0x4E, 0x5C, 0xB2, 0x87, 0x4F, 0xE2, 0xDD, 0xBC, 0x81, 0xD8, 0x2A, 0x23, 0x71, 0xAE, 0xD7, 0x3B}},
	{"TA-088v3 Ident Test 2 (4.05 IPL)", 143360, {0xCE, 0x29, 0x61, 0x35, 0xED, 0xD7, 0xF3, 0x90, 0x78, 0x2A, 0x3E, 0x70, 0x9C, 0xE1, 0xD8, 0x8A, 0x34, 0x6B, 0xD7, 0xB9}}
};

typedef struct {
	u8 BootStatus;
	u8 StartHead;
	u16 StartSector;
	u8 PartitionType;
	u8 LastHead;
	u16 LastSector;
	u32 AbsSector;
	u32 TotalSectors;
	u16 Signature;
	int IPLSpace;
	char* IPLName;
	int IPLSize;
} MSStruct;

const int IPLchecksums_count = sizeof(IPLchecksums) / sizeof(IPLchecksums[0]);
u8 sha1_blank[20] = {0x1C, 0xEA, 0xF7, 0x3D, 0xF4, 0x0E, 0x53, 0x1D, 0xF3, 0xBF, 0xB2, 0x6B, 0x4F, 0xB7, 0xCD, 0x95, 0xFB, 0x7B, 0xFF, 0x1D};

#define N_HI_ITEMS	500
int hi_texts[N_HI_ITEMS];
VlfPicture pic;